Prime Path
Time Limit: 1000MS | Memory Limit: 65536K | |
Total Submissions: 10869 | Accepted: 6181 |
Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
1733
3733
3739
3779
8779
8179
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3 1033 8179 1373 8017 1033 1033
Sample Output
6 7 0
Source
看题居然看半天,要好好学英文了,忧伤。。。
看似素数问题,其实就是搜索,用BFS+素性测试,大水题,居然调试了蛮久。。。
忧伤啊,贴代码咯:
/*
13052311 motefly 3126 Accepted 744K 32MS G++ 2585B 2014-07-10 12:20:05
*/
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <queue>
#include <cstring>
using namespace std;
bool prime(int n)
{
for(int i=2;i*i<=n;i++)
if(n%i==0)
return 0;
return 1;
}
int t,m,n;
int vis[10005];
void convert(int n,int &d1,int &d2,int &d3,int &d4)
{
d4=n%10;
d3=(n/10)%10;
d2=(n/100)%10;
d1=(n/1000)%10;
}
struct node
{
int num;
int cnt;
node(int n,int m):num(n),cnt(m){}
};
int d1,d2,d3,d4;
void bfs(int a,int b)
{
if(a==b)
{
printf("0\n");
return;
}
node nn(a,0);
memset(vis,0,sizeof(vis));
queue<node> q;
q.push(nn);
vis[nn.num]=1;
while(!q.empty())
{
node d=q.front();
convert(d.num,d1,d2,d3,d4);
for(int i=1;i<10;i++)
if(!vis[i*1000+d2*100+d3*10+d4]&&prime(i*1000+d2*100+d3*10+d4))
{
if(i*1000+d2*100+d3*10+d4==b)
{
printf("%d\n",d.cnt+1);
return;
}
node x(i*1000+d2*100+d3*10+d4,d.cnt+1);
q.push(x);
vis[i*1000+d2*100+d3*10+d4]=1;
}
for(int i=0;i<10;i++)
if(!vis[d1*1000+i*100+d3*10+d4]&&prime(d1*1000+i*100+d3*10+d4))
{
if(d1*1000+i*100+d3*10+d4==b)
{
printf("%d\n",d.cnt+1);
return;
}
node x(d1*1000+i*100+d3*10+d4,d.cnt+1);
q.push(x);
vis[d1*1000+i*100+d3*10+d4]=1;
}
for(int i=0;i<10;i++)
if(!vis[d1*1000+d2*100+i*10+d4]&&prime(d1*1000+d2*100+i*10+d4))
{
if(d1*1000+d2*100+i*10+d4==b)
{
printf("%d\n",d.cnt+1);
return;
}
node x(d1*1000+d2*100+i*10+d4,d.cnt+1);
q.push(x);
vis[d1*1000+d2*100+i*10+d4]=1;
}
for(int i=0;i<10;i++)
if(!vis[d1*1000+d2*100+d3*10+i]&&prime(d1*1000+d2*100+d3*10+i))
{
if(d1*1000+d2*100+d3*10+i==b)
{
printf("%d\n",d.cnt+1);
return;
}
node x(d1*1000+d2*100+d3*10+i,d.cnt+1);
q.push(x);
vis[d1*1000+d2*100+d3*10+i]=1;
}
q.pop();
}
}
int main()
{
cin>>t;
while(t--)
{
scanf("%d%d",&m,&n);
bfs(m,n);
}
return 0;
//convert(1605,d1,d2,d3,d4);
//cout<<d1<<" "<<d2<<" "<<d3<<" "<<d4<<endl;
}
加油加油啊!